current_update = 0
current_size = 0
current_totalsize = 0
current_percent = 0
current_kbps = 0
current_timeleft = 0

status_idle = 0
status_init = 1
status_connect = 2
status_dl = 3
status_save = 4
status_abort = 5
status_timeout = 6

update_status = status_idle

function parseURL(url)
   local ty = findpattern(url, '([a-zA-Z0-9-]*)://')
   ty = string.sub(ty, 0, string.len(ty) - 3)
   local dom = findpattern(url, '([a-zA-Z0-9-]*\.[a-zA-Z0-9-^/]*\.?[a-zA-Z0-9-]*/)', string.len(ty) + 4)
   dom = string.sub(dom, 0, string.len(dom) - 1)
   local pa = string.sub(url, string.len(ty) + string.len(dom) + 4)
   pos = -1
   while pos ~= nil do
      oldpos = pos
      pos = string.find(pa, '/', pos + 1)
   end
   local fi = string.sub(pa, oldpos + 1)
   pa = string.sub(pa, 0, string.len(pa) - string.len(fi))
   return ty, dom, pa, fi
end

function dl_feeds()
  if table.getn(rss_feeds.Data) >= 1 then
    for i = 1, table.getn(rss_feeds.Data) do
      dl_feed(i)
    end
  end
end

function dl_feed(index)
  if rss_feeds.Data[index] ~= nil then
    current_update = index
    dlfile(rss_feeds.Data[index].url, rss_feeds.Data[index].file, feeddir .. "rss" .. index ..".tmp")
  end
end

function dlfile(site,remotefile,savefile)
  System.currentDirectory(feeddir)
  
  -- reset global vars
  current_size = 0
  current_totalsize = 0
  current_percent = 0
  current_kbps = 0
  current_timeleft = 0

  local include_header_in_file = true
  local remove_file_on_abort = false
  
  local timeoutTimer = Timer.new()
  timeoutTimer:start()

  -- wait until connection is ready
  --update_status = status_init
  System.sleep(500)  -- slight delay to prevent hang/file overwrite issue?
  --[[
  while true do
	-- update screen
    draw_update()
    -- success
    ipAddress = Wlan.getIPAddress()
    if ipAddress then break end
	-- aborted
    if Controls.read():circle() then
      update_status = status_abort
      socket:close()
      return false
    end
	-- timed out
    if timeoutTimer:time() >= net_timeout * 1000 then
      update_status = status_timeout
      socket:close()
      return false
    end
  end
  
  timeoutTimer:reset()
  timeoutTimer:start()
  ]]

  update_status = status_connect
  socket, error = Socket.connect(site, 80)
  
  -- wait for connection to site
  while not socket:isConnected() do
    -- update screen
    draw_update()
	
	-- aborted
    if Controls.read():circle() then
      update_status = status_abort
	  socket:close()
      return false
    end
	
	-- timed out
    if timeoutTimer:time() >= net_timeout * 1000 then
      update_status = status_timeout
      socket:close()
      return false
    end
	
	-- prevent power save
    System.powerTick()
    
  end
  
  timeoutTimer:reset()
  timeoutTimer:start()

  local outf=io.open(savefile,"w")

  if outf then

    local buffer = ""
    local header = ""
    local line = ""
    local headerDone = false
    local recv = false
    local dlTimer=Timer.new()
    local min = 1
    local sec = 1
    local secleft = 1
    local kbps = 0 
    local bytesize = 0 
    local datasize = 0
    local size_done = 0

    bytesSent = socket:send("GET /"..remotefile.." HTTP/1.1\r\n")
    bytesSent = socket:send("host: "..site.."\r\n\r\n")
    
    update_status = status_dl    
    dlTimer:start()
    
	local header_searched = false
    local buff_size = 100
    local finishAttempt = 0
	local finishWait = 30
	local check_size = 0
	
	while true do
	  -- [start downloading]
	  
	  -- update screen
      draw_update()
    
	  -- input during download
    
	  -- input to abort
      if Controls.read():circle() then
        update_status = status_abort
		draw_update()
		
		socket:close()
        outf:write(buffer)
        outf:close()
		if remove_file_on_abort then
			System.removeFile(savefile)
		end
        return false
      end
	  
	  -- timed out
      if timeoutTimer:time() >= net_timeout * 1000 then
        update_status = status_timeout
		draw_update()
		
		socket:close()
        outf:write(buffer)
        outf:close()
		if remove_file_on_abort then
			System.removeFile(savefile)
		end
        return false
      end
	  
	  line = socket:recv() -- receive the next piece of the download
	  
	  if string.len(line) > 0 then
	    -- received data
		recv = true
        timeoutTimer:reset()
        timeoutTimer:start()
	    
		for i=1, buff_size do
          line = line .. socket:recv()
        end
		buffer = buffer .. line
		line = ""
		-- look for end of header
        --if string.contains(buffer,'\r\n\r\n') and not headerDone then
		eoh = string.find(buffer,"<")
		if not headerDone then
		  if eoh ~= nil then
		    -- search for end of header by looking for start of file (<)
		    headerDone = true
            header = string.sub(buffer, 1, eoh - 1)
			if include_header_in_file then
              -- include header in file
              buffer = header .. string.sub(buffer, eoh, string.len(buffer))
            else
              -- remove header from file
              buffer = string.sub(buffer, eoh, string.len(buffer))
            end
          else
		    -- search for end of header by looking for to empty lines
			if string.contains(buffer,'\r\n\r\n') then
			  headerDone = true
              parts=string.split(buffer,"\r\n\r\n")
			  header = parts[1]
			  if include_header_in_file then
			    buffer = header .. parts[2]
			  else
			    buffer = parts[2]  
			  end
			end
		  end
		else
		  if not header_searched then
		    -- search header
			headerLines = string.split(header,"\n")
            for i=1,table.getn(headerLines) do
              l= string.trim(headerLines[i])
              leng = string.contains(l,"Content(%-)Length(.+)")
              if leng then
                local sp = string.split(l," ")
                bytesize = tonumber(sp[2])
                datasize = tonumber(sp[2])/1024
                current_totalsize = string.format("%.2fkb", datasize)
              end
              if i == 2 then
                local sp = string.split(l," ")
				if sp ~= nil and table.getn(sp) >= 7 then
                  rss_feeds.Data[current_update].lastupdate = string.sub(sp[2], 1, string.len(sp[2]) - 1) .. sp[3] .. sp[4] .. sp[5] .. sp[6] .. sp[7]
			    end
              end
            end		  
			header_searched = true
		  end
		end
	  end

	  -- size of file
      if include_header_in_file then
        size_done = string.len(buffer)
      else
        size_done = string.len(buffer) - string.len(header)
      end

      -- calculations
      kbps = size_done/dlTimer:start()
      current_size = string.format("%.2fkb", size_done / 1024)
      current_kbps = string.format("%.1f", kbps)

      if datasize ~= 0 then
	    -- if download size is known, calculate percentage and time left
        current_percent = string.format("%d",((size_done / 1024)/datasize) * 100)
        secleft = math.floor((bytesize - size_done)/(kbps*1024))
        min = string.format("%d", secleft/60 )
        sec = string.format("%d", ((secleft/60)-min)*60 )
        current_timeleft = min .. " min(s) " .. sec .. " sec(s)"
      end

      if (recv == true and current_totalsize ~= 0) then
	    -- if we have received something, and know the download size, see if we are done
        if size_done >= bytesize then
		  -- save the file
          update_status = status_save
          outf:write(buffer)
          outf:close()
          socket:close()
          update_status = status_idle
          return true
        end
      elseif (recv == true and current_totalsize == 0 and string.len(line) == 0) then
	    -- if we have received something, and don't know the download size, see if the line is empty to determine end of file
		-- wait to ensure the file is done
		if check_size == 0 then
		  check_size = size_done
		else
		  if check_size ~= size_done then
		   -- we've received more data, reset finish attempt
		   check_size = size_done
		   finishAttempt = 0
		  else
		    finishAttempt = finishAttempt + 1
		    if finishAttempt >= finishWait then
		      -- save the file
			  update_status = status_save
              outf:write(buffer)
              outf:close()
              socket:close()
			  finishAttempt = 0
              update_status = status_idle
              return true
		    end
		  end
		end
	  end

	end
  else
   -- file error
   update_status = status_abort
   socket:close()
   return false
  end

end